#define PUL 5   // PUL > D5
#define DIR 4   // DIR > D4 (Drehrichtung)
#define ENBL 3  // ENBL > D3 (Freigabe)

#define tasterRechts 6  // D6 (Taster grün)
#define tasterLinks 7   // D7 (Taster blau)

#define drehpoti A0 //Drehpotentiometer am analogen Pin A0

const int PULSLAENGE = 500;
//wird über den Drehpoti gesetzt
int geschwindigkeit = 0;

void setup() {
  pinMode(PUL, OUTPUT);
  pinMode(DIR, OUTPUT);
  pinMode(ENBL, OUTPUT);
  pinMode(tasterRechts, INPUT_PULLUP);
  pinMode(tasterLinks, INPUT_PULLUP);
  digitalWrite(ENBL, HIGH);
}

void schrittBewegen(int drehrichtung) {
  //Drehrichtung
  //HIGH == links
  //LOW == rechts
  digitalWrite(DIR, drehrichtung);

  digitalWrite(PUL, HIGH);
  delayMicroseconds(PULSLAENGE);
  digitalWrite(PUL, LOW);
  delayMicroseconds(geschwindigkeit);
}

void loop() {
  //lesen des Drehpotentiometers für die Geschwindigkeit
  int drehpotiValue = analogRead(drehpoti);
  geschwindigkeit = drehpotiValue * 15 + 500;
  // nach rechts drehen
  if (digitalRead(tasterRechts) == LOW) {
    schrittBewegen(HIGH);
  }
  // nach links drehen
  if (digitalRead(tasterLinks) == LOW) {
    schrittBewegen(LOW);
  }
}